#include<bits/stdc++.h>
#define int long long
using namespace std;

const int INF = 1e18;

map<int, int> mp;

signed main() {
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    int t;
    cin >> t;
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> tt(2);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        tt[a[i] & 1]++;
    }
    string s;
    cin >> s;
    if (!tt[0] || !tt[1]) {
        cout << "Yes\n";
        cout << (m + 1) / 2 << '\n';
        cout << 1 << '\n';
        cout << m / 2 << ' ' << (m + 1) / 2 << '\n';
    } else {
        cout << "No\n";
    }
}